module.exports = function (args) {
	/**
	 * Currently there is no arg processing so you need to do it the
	 * shi--AWESOME way:
	 *
	 * ts <ts args> -- <cmd args>
	 *
	 * You need at least one ts arg, the ts file to run. To pass
	 * arguments to the command, mark the end of the TypeScript
	 * arguments with a "--" argument, Unix-style, before specifying
	 * the command arguments.
	 */
	const _fs = require('fs');
	const _proc = require('child_process');
	const _path = require('path');

	args.shift();
	args.shift();
	let tsArgs = args.shift();
	let arg = args.shift();
	while (typeof arg !== 'undefined' && arg !== '--') {
		tsArgs.push(arg);
		arg = args.shift();
	}
	let cmdArgs = args;


	var deleteFolderRecursive = function (path) {
		if (_fs.existsSync(path)) {
			_fs.readdirSync(path).forEach(function (file, index) {
				var curPath = path + _path.sep + file;
				if (_fs.lstatSync(curPath).isDirectory()) { // recurse
					deleteFolderRecursive(curPath);
				} else { // delete file
					_fs.unlinkSync(curPath);
				}
			});
			_fs.rmdirSync(path);
		}
	};

	let tmpDir;
	try {
		// NodeJS v6 changed to a new library which doesn't work with ImDisk (or some AD shares?).
		tmpDir = _fs.mkdtempSync(process.env.TEMP + path.sep)
	} catch (e) {
		tmpDir = _fs.mkdtempSync('C:\\Temp' + _path.sep);
	}
	const tmpFile = tmpDir + _path.sep + 'ts-output';


	tsArgs = ['--outFile', tmpFile].concat(tsArgs);
	cmdArgs = [tmpFile].concat(cmdArgs);
	try {
		let tscProc = _proc.execFile('tsc', tsArgs);
		tscProc.stdout.pipe(process.stdout);
		tscProc.stderr.pipe(process.stderr);
		tscProc.on('exit', (code, signal) => {
			let execProc = _proc.execFile('node', cmdArgs); // lol
			execProc.stdout.pipe(process.stdout);
			execProc.stderr.pipe(process.stderr);
			setTimeout(function () { deleteFolderRecursive(tmpDir); }, 1000);
		}).on('error', (e) => {
			throw e;
		});
		//vm.runInThisContext
		//eval(require('fs').readFileSync(tmpFile, 'utf8'));
	} catch (e) {
		deleteFolderRecursive(tmpDir);
		throw e;
	}
}